package web_server.sim.schelling_180206;

import java.util.ArrayList;

import processing.core.PVector;

public class Clusters {
	int[][] data;
	boolean[][] calc;

	public Clusters( int[][] data ) {
		this.data = data;
	}
	
	public ArrayList<Cluster> GenerateClusters() {
		calc = new boolean[data.length][data[0].length];
		
		ArrayList<Cluster> results = new ArrayList<Cluster>();

		for (int i = 0; i < calc.length; i++) {
			for (int j = 0; j < calc[0].length; j++) {
				if (!calc[i][j]) {
					calc[i][j] = true;
					
					Cluster c = new Cluster(data[i][j]);
					c.indices.add(new int[] {i,j});
					c.addNeighbours(i,j);
					c.finalize();
					
					
					if (c.area > 10) {
						results.add(c);
					}
				}
			}
		}		
		return results;
	}
	
	
	public class Cluster {
		ArrayList<int[]> indices = new ArrayList<int[]>();
		ArrayList<int[][]> edges = new ArrayList<int[][]>();
		
		int culture = -1;
		int area = 0;
		int perim = 0;
		
		public Cluster(int culture) {
			this.culture = culture;
		}
		
		public void addNeighbours( int i , int j ) {
			if ( i-1 > -1 && !calc[i-1][j] && data[i][j] == data[i-1][j]) {
				indices.add(new int[] {i-1, j});
				calc[i-1][j] = true;
				addNeighbours(i-1,j);
			} else {
				if ( i-1 < 0 || data[i][j]!=data[i-1][j])
					edges.add(new int[][] { {i,j} , {i,j+1} } );
			}
			
			if ( j-1 > -1 && !calc[i][j-1] && data[i][j] == data[i][j-1]) {
				indices.add(new int[] {i, j-1});
				calc[i][j-1] = true;
				addNeighbours(i,j-1);
			} else {
				if ( j-1 < 0 || data[i][j]!=data[i][j-1])
					edges.add(new int[][] { {i,j} , {i+1,j} } );
			}
			
			if ( i+1 < calc.length && !calc[i+1][j] && data[i][j] == data[i+1][j]) {
				indices.add(new int[] {i+1, j});
				calc[i+1][j] = true;
				addNeighbours(i+1,j);
			} else {
				if ( i+1 > data.length-1 || data[i][j]!=data[i+1][j])
					edges.add(new int[][] { {i+1,j} , {i+1,j+1} } );
			}
			
			if ( j+1 < calc.length && !calc[i][j+1] && data[i][j] == data[i][j+1]) {
				indices.add(new int[] {i, j+1});
				calc[i][j+1] = true;
				addNeighbours(i,j+1);
			} else {
				if ( j+1 > data.length-1 || data[i][j]!=data[i][j+1])
					edges.add(new int[][] { {i,j+1} , {i+1,j+1} } );
			}
		}
		
		public void finalize() {
			area = indices.size();
			perim = edges.size();
		}
	}
}
