package web_server.sim.schelling_180206;

import java.util.ArrayList;
import processing.core.PVector;
import processing.data.JSONObject;

// subclass : culture parameters
public class Culture { 
	static String[] CultureControls = new String[] { "Threshold", "MaxThreshold", "Density", "Obligatoriness", "Exclusivity", "NumVenues", "NeighDist", "VenDist" };	
	
	float cohesionParameter;
	float maxCohesionParameter;
	int neighbourhoodDist;
	int venueTravelDist;
	float popDensity;	
	float obligatoriness;
	float exclusivity;
	int numVenues;
	ArrayList<PVector> VenueLocations;
	ArrayList<PVector> AgentLocations;
	int identityCode;
	
	public Culture(JSONObject joc) {
		this.cohesionParameter = joc.getFloat("Threshold");
		this.maxCohesionParameter = joc.getFloat("MaxThreshold");
		this.neighbourhoodDist = joc.getInt("NeighDist");
		this.venueTravelDist = joc.getInt("VenDist");
		this.popDensity = joc.getInt("Density")/100f;
		this.obligatoriness = joc.getFloat("Obligatoriness");
		this.exclusivity = joc.getFloat("Exclusivity");
		this.numVenues = joc.getInt("NumVenues");
		this.identityCode = joc.getInt("id");
		this.VenueLocations = new ArrayList<PVector>();
		
		String sv = joc.getString("VenLocations");
		if (sv.length() > 0 && sv.indexOf("&") > -1) {
			String[] svlz = sv.split("&");
			
			for (int a = 0; a < svlz.length; a+=2) {
				VenueLocations.add( new PVector ( (int) Float.parseFloat(svlz[a]), (int) Float.parseFloat(svlz[a+1]) ) );
			}
		}
		
		this.AgentLocations = new ArrayList<PVector>();
		
		sv = joc.getString("AgentLocations");
		if (sv.length() > 0 && sv.indexOf("&") > -1) {
			String[] svlz = sv.split("&");
			
			for (int a = 0; a < svlz.length; a+=2) {
				AgentLocations.add( new PVector ( (int) Float.parseFloat(svlz[a]), (int) Float.parseFloat(svlz[a+1]) ) );
			}
		}
	}
}
