package web_server.sim.schelling_180206;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.PrintWriter;
import java.net.URL;
import java.nio.file.Files;
import java.time.LocalDateTime;
import processing.core.PApplet;
import processing.data.JSONArray;
import processing.data.JSONObject;

public class Sim_ReadWrite {
	PApplet parent;
	String base = "";
	int ga_Counter = 0;
	
	public Sim_ReadWrite (PApplet parent, String base) {
		this.parent = parent;
		this.base = base;
	}
	
	public void SaveSettings ( JSONArray gSettings ) {
		
	}
	
	public void TempSaveText ( int i, JSONObject jrun) {
		// save out a single run into a single file, for easy loading at any time..
		PrintWriter pw =  parent.createWriter (base + "Temp//" + i + ".txt" );

		pw.println(jrun.toString());
		pw.flush();
		pw.close();
	}
	
	public void CompressedSave(  double[] param, JSONObject gSettings, JSONObject gResults, float fr, int et) {
		ga_Counter++;
		
		String date = LocalDateTime.now().getYear() + " " + LocalDateTime.now().getDayOfYear() 
							+ " " + LocalDateTime.now().getHour() + " " +  LocalDateTime.now().getMinute() 
							+ " " + LocalDateTime.now().getSecond() + " " + LocalDateTime.now().getNano();
		String paramm = "";
		for (int i = 0; i < param.length; i++) paramm += param[i] + "*";
		
		try {
			PrintWriter pw = new PrintWriter( new FileOutputStream( new File(base + "ref.txt"), true));
			pw.println(date + "," + paramm + "," + fr);
			pw.flush();
			pw.close();
		} catch (FileNotFoundException e1) {		} 
		

		try {
			PrintWriter pw = new PrintWriter( new FileOutputStream( new File(base + date + "_" + ga_Counter + "_results.txt"), true));
			JSONObject jj = new JSONObject();
		
			JSONObject jow = gResults.getJSONArray("World").getJSONObject(et);
			String s2 = jow.getString("tempWorld");
			
			jj.setJSONObject("settings", gSettings);
			jj.setString("Results", s2);
			
			pw.println(jj.toString());
			
			pw.flush();
			pw.close();

		} catch (Exception e) { }
	}
	
	
	public void PermaSaveText (String author, String desc, JSONObject gSettings, JSONObject gAnalysis, SingleRun[] sr) {
		// adds a line to the reference file, writes a file with some overall details (such as the number of iterations and steps?), and copies the temp files
		
		String date = LocalDateTime.now().getYear() + " " + LocalDateTime.now().getDayOfYear() + " " + LocalDateTime.now().getHour() + " " +  LocalDateTime.now().getMinute() + " " + LocalDateTime.now().getSecond();
		try {
			PrintWriter pw = new PrintWriter( new FileOutputStream( new File(base + "ref.txt"), true));
			pw.println(date + "," + sr.length + "," + author + "," + desc);
			pw.flush();
			pw.close();
		} catch (FileNotFoundException e1) {		} 
		
		for (int i = 0; i < sr.length; i++) {
			String s = base + "Temp//" + i + ".txt";
			String s2 = base + date + "//" + i + ".txt";
			
			File fis =  new File(s);
			FileOutputStream fos;
			File dir = new File(base+date+"//");
			
			if (!dir.exists()) {
				try{
					dir.mkdir();
				} catch(Exception se){	System.out.println(se.toString()); return;	    }
			}
			
			try {
				fos = new FileOutputStream(s2);
				Files.copy(fis.toPath(),fos);
			} catch (Exception e) {			}
			
		}
		
		/* GLOBAL SETTINGS */
		try {
			PrintWriter pw = new PrintWriter( new FileOutputStream( new File(base + date + "//_gSettings.txt"), true));
			pw.println( gSettings.toString() );
			pw.flush();
			pw.close();
		} catch (Exception e) { }
		
		/* GLOBAL ANALYSIS */
		try {
			PrintWriter pw = new PrintWriter( new FileOutputStream( new File(base + date + "//_gAnalysis.txt"), true));
			pw.println( gAnalysis.toString() );
			pw.flush();
			pw.close();
		} catch (Exception e) { }
	}

	
	public String[] Load() {
		return parent.loadStrings(base + "ref.txt");
	}
	
	public void CreateOrClearTempFolder () {
		PrintWriter pw =  parent.createWriter (base + "Temp//0.txt" );
	}
	
	public void WipeTemp( ) {
		File dir = new File(base + "Temp//");
		for(File file: dir.listFiles()) 
		    if (!file.isDirectory()) 
		        file.delete();
	}
}
